<?php


include "config.php";




$oid = "MG20240506105131"; // Assuming you have a specific order ID to process
$action = $_POST['action'];

// Update order status
$sql = "SELECT `awb` FROM `checkout` WHERE `shipping`!='0'";
$result = mysqli_query($conn, $sql);

if ($result) {
    while ($row = mysqli_fetch_assoc($result)) {
        $awb = $row['awb'];
        $token = createtoken();

        if ($token) {
            $shippingResponse = scheduleExpressBeesPickup($awb, $token);
            if ($shippingResponse) {
                if ($shippingResponse['data']['status'] == true) {
                    updateOrderDetails($oid, $shippingResponse);
                    echo json_encode(["message" => true, "data" => $shippingResponse['data']['status']]);
                } else {
                    echo json_encode(["message" => false, "data" => $shippingResponse]);
                }
            } else {
                echo json_encode(["message" => "Failed to retrieve pickup details"]);
            }
        } else {
            echo json_encode(["message" => "Failed to create token"]);
        }
    }
} else {
    echo json_encode(["message" => "Failed to update order status"]);
}

// Function to create token
function createtoken()
{
    $data = array(
        'email' => 'shrutinilesh7904@gmail.com', // Replace with your email
        'password' => 'Nilesh@1234' // Replace with your password
    );

    $url = 'https://shipment.xpressbees.com/api/users/login';

    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));

    $response = curl_exec($ch);
    $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    if ($httpcode == 200) {
        $responseData = json_decode($response, true);
        return $responseData['data']; // Return the token
    } else {
        return null; // Return null if token retrieval fails
    }
}

// Function to schedule pickup
function scheduleExpressBeesPickup($awb, $token)
{
    $expressBeesApiUrl = 'https://shipment.xpressbees.com/api/shipments2/track/'.$awb;

    // Make API call to retrieve pickup details
    $ch = curl_init($expressBeesApiUrl);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array(
        'Content-Type: application/json',
        'Authorization: Bearer ' . $token
    ));

    $response = curl_exec($ch);
    curl_close($ch);

    $responseData = json_decode($response, true);
    return $responseData;
}

// Function to update order details after pickup scheduling
function updateOrderDetails($oid, $shippingResponse)
{
    // Update order details in database
    global $conn;
    $sid = $shippingResponse['data']['shipment_id'];
    $awb = $shippingResponse['data']['awb_number'];
    $label = $shippingResponse['data']['label'];
    $cid = $shippingResponse['data']['courier_id'];
    $status = $shippingResponse['data']['status'];
    
    if($status == "delivered"){
        $st = "Order Completed";
    }else{
        $st = $status;
    }
    

    $sql = "UPDATE `checkout` SET  `status`='$st' WHERE `orderid`='$oid'";
    $result = mysqli_query($conn, $sql);
}

?>
